"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Class = void 0;
var os = __importStar(require("os"));
var ComponentKind_1 = require("../Models/ComponentKind");
var Class = (function () {
    function Class(name) {
        this.componentKind = ComponentKind_1.ComponentKind.CLASS;
        this.isAbstract = false;
        this.isStatic = false;
        this.constructorMethods = [];
        this.members = [];
        this.implementsInterfaces = [];
        this.typeParameters = [];
        this.name = name;
    }
    Class.prototype.toPUML = function () {
        var result = [];
        var firstLine = [];
        if (this.isAbstract) {
            firstLine.push('abstract ');
        }
        firstLine.push("class " + this.name);
        if (this.typeParameters.length > 0) {
            firstLine.push('<');
            firstLine.push(this.typeParameters
                .map(function (typeParameter) { return typeParameter.toPUML(); })
                .join(', '));
            firstLine.push('>');
        }
        if (this.extendsClass !== undefined) {
            firstLine.push(" extends " + this.extendsClass);
        }
        if (this.implementsInterfaces.length > 0) {
            firstLine.push(" implements " + this.implementsInterfaces.join(', '));
        }
        if (this.members.length > 0) {
            firstLine.push(' {');
        }
        result.push(firstLine.join(''));
        this.members.forEach(function (member) {
            result.push("    " + member.toPUML());
        });
        if (this.members.length > 0) {
            result.push('}');
        }
        return result.join(os.EOL);
    };
    return Class;
}());
exports.Class = Class;
